/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

#include "extern.h"

T_Entry *interf_old_entry;

static Interf *se_interf [MAX_STATE];

Interf *interf_from_sublist (name, sublist)
char *name;
Node *sublist;
{
	Interf *interf;
	int i, num;
	Node *sub, *temp;

	interf = (Interf*) U_malloc (sizeof (Interf));

	interf->name = name;
	num = 1;
	for (LIST_LOOP (sub, sublist, temp))
		num++;

	interf->nargs = num;
	interf->entry = (T_Entry**) U_malloc (sizeof (T_Entry*) * interf->nargs);

	num = 1;
	for (LIST_LOOP (sub, sublist, temp)) {
		interf->entry[num] = (T_Entry*) U_malloc (sizeof (T_Entry));
		interf->entry[num]->typ = typ_malloc ();

		if (sub->Subscript.Times == NN)
			interf->entry[num]->typ->etype = sub->Subscript.Expr->com.typ->etype;
		else
			interf->entry[num]->typ->etype = Etype_INTEGER_0;

		num++;
	}

	return interf;
}

interf_begin (name, namelist)  /* starts interf, called just after Fun or Sub stmt */
char *name;
Node *namelist;
{
	int num, i;
	Node *arg, *temp;

	se_interf [state_level] = (Interf*) U_malloc (sizeof (Interf));
	se_interf [state_level]->name = name;

	num = 1;  /* num = 0 is used for the function */
	for (LIST_LOOP (arg, namelist, temp))
		num++;

	se_interf [state_level]->nargs = num;
	se_interf [state_level]->args = (char**) U_malloc (sizeof (char*) * num);

	num = 0;

	se_interf [state_level]->args[num++] = name;

	namelist = list_invert (namelist);
	for (LIST_LOOP (arg, namelist, temp))
		se_interf [state_level]->args[num++] = arg->com.str;
}

interf_enddecl ()  /* ends interface */
{
	int i, j;
	T_Entry *arg, *arg_cp, *fun, *oldfun, *tentry;
	Node *sublist;
	Shape *shape;
	char *name;
	Etype *etype = EN;

	if (scoping_unit [state_level] == UNIT_PROGRAM
	|| scoping_unit [state_level] == UNIT_MODULE
	|| scoping_unit [state_level] == UNIT_BLOCK_DATA)
		return;

/* next IF is necessary to set correctly the type in for example:

	FUNCTION FUN ()
	COMPLEX FUN
	...
*/

	if (scoping_unit [state_level] == UNIT_FUNCTION) {
		char *funname = se_interf [state_level]->name;
		T_Entry *funentry, *funentry_loc;
		Etype *loc_etype;
		Node *sublist;
		Shape *fun_shape = SN;

		if ((funentry_loc = lookup_loc (funname)) != TN) {
			loc_etype = funentry_loc->typ->etype;
			fun_shape = funentry_loc->typ->shape;
		}
		else
			loc_etype = EN;

		if (loc_etype != EN && se_FunctionStmt_etype != EN)
			if (etype_ne (loc_etype, se_FunctionStmt_etype)) {
				sprintf (serr, "type for function '%s' ambiguous", funname);
				fatal (serr);
			}

			if (loc_etype != EN)
				etype = loc_etype;
			else if (se_FunctionStmt_etype != EN)
				etype = se_FunctionStmt_etype;
			else
				etype = implicit_get (funname);

		funentry = install_glo (funname, TAB_TYP_ETYPE, etype);
		funentry->typ->shape = fun_shape;
		SET_function (funentry);

		if (funentry_loc != TN && funentry_loc->node != NN
		&& (sublist = ENTRY_SUBLIST (funentry_loc)) != NN
        && expr_sublist_not_constant (sublist)) {
			SET_assumed_pass (funentry_loc);
			SET_assumed_shape (funentry_loc);
			SET_assumed_pass (funentry);
			SET_assumed_shape (funentry);
			desc_put_in_table (funentry);
		}

		if (!se_in_interface)
			SET_defined_proc (funentry);
	}

	fun = lookup_user (se_interf [state_level]->name);

#ifdef CHECK
	if (fun == TN) {
		SYSERR;
		return;
	}
#endif

	se_interf [state_level]->entry = (T_Entry**) U_malloc (sizeof (T_Entry*) * se_interf [state_level]->nargs);

	for (i = 0; i < se_interf [state_level]->nargs; i++) {
		name = se_interf [state_level]->args[i];

		if (i) {
			if (se_interf [state_level]->args [i] == (char*) 0) {	/*!!! (*) stuff */
				name = se_interf [state_level]->args [i] = "*";

				if ((arg = lookup_loc  (name)) == (T_Entry*) 0)
					arg = install_loc (name, TAB_TYP_ETYPE, Etype_INTEGER_0);	/*!!! (*) stuff */
			}
			else if ((arg = lookup_loc  (name)) == (T_Entry*) 0) {
				if (strncmp (name, "*", 1))	/*!!! (*) stuff */
					etype = implicit_get (name);
				else
					etype = Etype_INTEGER_0;

				arg = install_loc (name, TAB_TYP_ETYPE, etype);
			}

			SET_argument (arg);
		}
		else if (fun != TN && IS_function (fun)) {
			if ((arg = lookup_loc (name)) == (T_Entry*) 0) {
				arg = install_loc (name, TAB_TYP_ETYPE, etype);
			}

			SET_result (arg);

			if (IS_array (arg)
			&& (sublist = ENTRY_SUBLIST (arg)) != NN
			&& expr_sublist_not_constant (sublist)) {
				SET_array (fun);
				SET_automatic (fun);
			}
		}
		else {
			arg = install_loc (name, TAB_INSTALL, 0);
		}

		arg_cp = table_entry_cp (arg);
		se_interf [state_level]->entry[i] = arg_cp;
	}

/* checks */

	if ((oldfun = interf_old_entry) == TN)
		goto skip;

	if (se_in_interface) {
		if (IS_explicit (oldfun)) {  /* explicit interface was defined previously */
/*!!! temporary fix to allow for repeated local definitions of interfaces
			sprintf (serr, "redefinition of interface for procedure '%s'"
			               , se_interf [state_level]->name);
			fatal (serr);
*/
			;
		}
		else if (IS_implicit (oldfun)) {  /* check current with previous implicit */
			int give_fatal = IS_explicit (oldfun);
			interf_check_interf (oldfun->interf, se_interf [state_level], give_fatal);
		}
	}
	else {
		int give_fatal = IS_explicit (oldfun);
		interf_check_interf (oldfun->interf, se_interf [state_level], give_fatal);
	}

skip:

	if (se_in_interface) {
		SET_explicit (fun);
		fun->interf = se_interf [state_level];  /* explicit stays */
	}
	else {
		if (oldfun != TN
		&& IS_explicit (oldfun)) {  /* unless previous was explicit, new stays */
			fun->interf = oldfun->interf;
		}
		else {
			SET_implicit (fun);
			fun->interf = se_interf [state_level];
		}
	}

	if (scoping_unit [state_level] == UNIT_FUNCTION) {  /* argument type must agree with function */
		if (fun->typ->etype != EN
		&& fun->interf->entry[0]->typ->etype != EN
		&& etype_ne (fun->typ->etype, fun->interf->entry[0]->typ->etype)) {
			;
/*!!! do only if explicit type for function in function statement 
			sprintf (serr, "conflictive type for function '%s'", se_interf [state_level]->name);
			fatal (serr);
*/
		}

		fun->typ->shape = shape_copy (fun->interf->entry[0]->typ->shape);	

		if (IS_automatic (fun)) {
			Shape *shape;
			int j;

			shape = fun->typ->shape;

			for (j = 0; j < shape->rank; j++)
				shape->sizes1[j] = shape->extent[j] =
				desc_extent (se_interf [state_level]->name, j);
/*
				shape->sizes1[j] = shape->extent[j] = &Times;
*/
		}

		fun->attr_array = fun->interf->entry[0]->attr_array; /*!!! prob. need more */
	}

	if (over_in)
		U_stack_push_overs (fun);

	se_interf [state_level] = (Interf*) 0;
}

interf_check_interf (i1, i2, give_fatal)
Interf *i1, *i2;
int give_fatal;
{
	int i;

	if (i1 == (Interf*) 0 || i2 == (Interf*) 0)
		return;

	if (i1->nargs != i2->nargs) {
		sprintf (serr
		, "procedure '%s' is called with a different number of arguments than in a previous definition: is %d, was %d"
		, i2->name, i2->nargs - 1, i1->nargs - 1);

		if (give_fatal)
			fatal (serr);
		else
			warning (serr);
	}

	for (i = 1; i < U_MIN (i1->nargs, i2->nargs); i++) {
		if (etype_ne (i1->entry[i]->typ->etype, i2->entry[i]->typ->etype)) {
			sprintf (serr 
			   , "argument %d for procedure '%s' has different type than in a previous definition: is %s, was %s"
			   , i, i2->name
			   , etype_name (i2->entry[i]->typ->etype)
			   , etype_name (i1->entry[i]->typ->etype));

			if (give_fatal)
				fatal (serr);
			else
				warning (serr);
		}
	}

	for (i = 1; i < U_MIN (i1->nargs, i2->nargs); i++) {
		if (!typ_rank_eq (i1->entry[i]->typ->shape, i2->entry[i]->typ->shape)) {
			sprintf (serr 
			   , "argument %d for procedure '%s' has different rank than in a previous definition: is %d, was %d"
			   , i, i2->name
			   , RANK_FROM_SHAPE (i2->entry[i]->typ->shape)
			   , RANK_FROM_SHAPE (i1->entry[i]->typ->shape));

			if (give_fatal)
				fatal (serr);

			/* doesn't give warning as it is OK if there is not explicit interface */
		}
	}
}

#ifdef CHECK
interf_show (interf)
Interf *interf;
{
	int i;
	T_Entry *entry;

	if (interf == (Interf*) 0)
		return;

	entry = lookup_glo (interf->name);

	printf (" Interface:\n");

	if (IS_function (entry))
		i = 0;
	else
		i = 1;

	for (; i < interf->nargs; i++) {
		putchar ('\t');
		table_show_entry (interf->entry[i]);
		if (i != interf->nargs - 1)
			putchar ('\n');
	}
}
#endif

interf_set_assumed_list (sublist)
Node *sublist;
{
	Node *sub, *temp;

	for (LIST_LOOP (sub, sublist, temp))
		interf_set_assumed (sub);
}

interf_set_assumed (sub)  /*  SETs assumed_pass */
Node *sub;
{
	T_Entry *subentry;
	int type;

	switch (type = sub->Subscript.Expr->com.type) {

	case ARRAY_SECTION:
		subentry = lookup (sub->Subscript.Expr->com.str, TAB_LOCAL);
		SET_assumed_pass (subentry);
		desc_put_in_table (subentry);
		break;


#ifdef CHECK
	case DUM_EXPR:
		SYSERR;
		break;
#endif

	case NAME:  /* can happend if replaced temp or _desc */
		subentry = lookup (sub->Subscript.Expr->com.str, TAB_LOCAL);
		SET_assumed_pass (subentry);
		desc_put_in_table (subentry);
		break;

	case DUM_ARR_CONS:
		subentry
		= lookup (sub->Subscript.Expr->DumArrCons.Expr->com.str, TAB_LOCAL);
		SET_assumed_pass (subentry);
		desc_put_in_table (subentry);
		break;

	case INTEGER_CONSTANT:
	case BINARY_CONSTANT:
	case CHARACTER_CONSTANT:
	case HEX_CONSTANT:
	case LOGICAL_CONSTANT:
	case OCTAL_CONSTANT:
	case REAL_CONSTANT:
		break;

#ifdef CHECK
	default:
		syserr_internal ("OK if doing error recovery");
#endif
	}
}

int interf_is_argument (entry)  /* 1 if entry is an argument to the current procedure */
T_Entry *entry;
{
	int i;

	if (se_interf [state_level] == (Interf*) 0)
		return 0;

	for (i = 1; i < se_interf [state_level]->nargs; i++)
		if (!U_strcmp_nocase (entry->name, se_interf [state_level]->args [i]))
			return 1;

	return 0;
}

interf_set_intent_in (entry)
T_Entry *entry;
{
	Interf *interf = entry->interf;
	Over *over = entry->over;
	int i;

	if (interf != (Interf*) 0) {
		for (i = 1; i < interf->nargs; i++) {
			SET_intent_in (interf->entry[i]);
		}
	}
	else if (over != (Over*) 0)
		for (i = 0; i < over->nover; i++)
			interf_set_intent_in (over->entry[i]);
}
